#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int main(int argc, char** argv) 
{
	int t;
	scanf("%d", &t);
	int n, m;
	int c[t];
	for(int i = 0; i < t; i++)
	{
		scanf("%d%d", &n, &m);
		long long min1 = LLONG_MAX;
		long long a[n], b[m];
		for(int j = 0; j < n; j++)
		{
			cin >> a[j];
		}
		for(int j = 0; j < m; j++)
		{
			cin >> b[j];
		}
		for(int j = 0; j < n - 1; j++)
		{
			for(int k = j + 1; k < n; k++)
			{
				if(abs(a[j] - a[k]) < min1) min1 = abs(a[j] - a[k]);
			}
		}
		c[i] = 1;
		long long ost = a[0] % min1;
		for(int j = 0; j < m; j++)
		{
			if(ost == b[j] % min1)
			{
				c[i] = 0;
				break;
			}
		}
	}
	for(int i = 0; i < t; i++)
	{
		printf("%d\n", c[i]);
	}
	return 0;
}